(* L3 compiler
 * stringifier
 * turns a list of x86 insns into the assembly code to generate them
 * Author: Chris Lu <czl@andrew.cmu.edu>
 *)

signature STRINGIFY =
sig
  type asm = Blarg.insn list
  val stringify : (string -> string) -> asm -> string
end

structure Stringify :> STRINGIFY =
struct
  type asm = Blarg.insn list
  structure X = Blarg

  (* val stringify : asm -> string
   * turns a x86 instruction list into a string of assembly code for these instructions *)

  fun (*stringify' rn (X.CALL (l, n)) = X.print (X.CALL ((Symbol.symbol (rn (Symbol.name l))), n))
    | *)stringify' rn x = X.print x

  (* val stringify : asm -> string *)
  fun stringify realname l = String.concat (List.map (stringify' realname) l)

end
